# generated by datamodel-codegen:
#   filename:  https://development.zaaksysteem.nl/api/v2/document/openapi/openapi30.json
#   timestamp: 2022-11-17T10:44:34+00:00

from __future__ import annotations

from datetime import date, datetime
from enum import Enum
from pydantic import BaseModel, Extra, Field
from typing import Any, Dict, List, Optional
from uuid import UUID


class Meta(BaseModel):
    last_modified_datetime: Optional[datetime] = None
    created_datetime: Optional[datetime] = None
    document_number: Optional[int] = None


class Data1(BaseModel):
    id: Optional[UUID] = None
    type: Optional[str] = Field(None, example="case")


class Meta1(BaseModel):
    display_number: Optional[float] = Field(None, example=1740)


class Case(BaseModel):
    data: Optional[Data1] = None
    meta: Optional[Meta1] = None


class Data2(BaseModel):
    id: UUID
    type: str = Field(..., example="directory")


class Directory(BaseModel):
    data: Data2


class Data3(BaseModel):
    id: UUID
    type: str = Field(..., example="subject")


class Meta2(BaseModel):
    display_name: Optional[str] = Field(None, example="Admin")


class ModifiedBy(BaseModel):
    data: Optional[Data3] = None
    meta: Optional[Meta2] = None


class Data4(BaseModel):
    id: UUID
    type: str = Field(..., example="subject")


class Meta3(BaseModel):
    display_name: Optional[str] = Field(None, example="Admin")


class LockedBy(BaseModel):
    data: Data4
    meta: Optional[Meta3] = None


class Data5(BaseModel):
    id: UUID
    type: str = Field(..., example="subject")


class Meta4(BaseModel):
    display_name: Optional[str] = Field(None, example="Admin")


class CreatedBy(BaseModel):
    data: Data5
    meta: Optional[Meta4] = None


class Data6(BaseModel):
    id: UUID
    type: str = Field(..., example="file")


class File(BaseModel):
    data: Data6


class Relationships(BaseModel):
    class Config:
        extra = Extra.forbid

    case: Optional[Case] = Field(None, description="Case this document is related to")
    directory: Optional[Directory] = Field(
        None, description="Directory this document is part of (map / folder / directory)"
    )
    modified_by: Optional[ModifiedBy] = Field(
        None, description="Subject making the last change to this document"
    )
    locked_by: Optional[LockedBy] = Field(
        None, description="Subject making the last change to this document"
    )
    created_by: CreatedBy = Field(..., description="Subject created this document")
    file: File = Field(..., description="File this document is related to")


class Type(Enum):
    danslist2018 = "danslist2018"


class Archive(BaseModel):
    type: Optional[Type] = None
    is_archivable: Optional[bool] = None


class VirusStatus(Enum):
    pending = "pending"
    ok = "ok"


class Security(BaseModel):
    virus_status: Optional[VirusStatus] = None


class State(Enum):
    pending = "pending"
    active = "active"
    rejected = "rejected"
    deleted = "deleted"


class PendingType(Enum):
    filename_exists = "filename_exists"
    no_permission = "no_permission"


class Status(BaseModel):
    state: Optional[State] = None
    pending_type: Optional[PendingType] = None
    reason: Optional[str] = Field(None, description="In case of rejected, this is the reason why")


class Lock(BaseModel):
    since: Optional[datetime] = Field(None, description="(e.g. locked) since")


class Origin(Enum):
    Uitgaand = "Uitgaand"
    Intern = "Intern"
    Inkomend = "Inkomend"


class Publish(BaseModel):
    status: Optional[bool] = Field(None, example=True)
    destinations: Optional[List[str]] = None


class Meta5(BaseModel):
    last_modified_datetime: Optional[datetime] = None
    created_datetime: Optional[datetime] = None
    summary: Optional[str] = Field(None, example="parkingpermit.pdf")
    table_id: Optional[int] = Field(None, example=1234)


class Relationships1(BaseModel):
    document: Optional[Dict[str, Any]] = Field(
        None, description="Document this storage item links to, if available"
    )
    thumbnail: Optional[Dict[str, Any]] = Field(None, description="Related thumbnail")
    created_by: Optional[Dict[str, Any]] = Field(
        None, description="Subject created this entry in the file"
    )


class Type1(Enum):
    md5 = "md5"


class Hash(BaseModel):
    type: Optional[Type1] = None
    value: Optional[str] = Field(None, example="9b36b2e89df94bc458d629499d38cf86")


class Type2(Enum):
    danslist2018 = "danslist2018"


class Archive1(BaseModel):
    type: Optional[Type2] = None
    is_archivable: Optional[bool] = None


class VirusStatus1(Enum):
    pending = "pending"
    ok = "ok"


class Security1(BaseModel):
    virus_status: Optional[VirusStatus1] = None


class Attributes1(BaseModel):
    name: Optional[str] = Field(
        None, description="Fullname of the file with extension", example="parkingpermit.pdf"
    )
    basename: Optional[str] = Field(
        None, description="Name without extension", example="parkingpermit"
    )
    extension: Optional[Any] = Field(None, description="Extension of this file", example="pdf")
    hash: Optional[Hash] = None
    archive: Optional[Archive1] = None
    security: Optional[Security1] = None
    filesize: Optional[float] = None
    mimetype: Optional[str] = None


class FileEntity(BaseModel):
    type: Optional[str] = Field(None, example="file")
    id: Optional[UUID] = None
    meta: Optional[Meta5] = None
    relationships: Optional[Relationships1] = None
    attributes: Optional[Attributes1] = None


class Download(BaseModel):
    class Config:
        extra = Extra.forbid

    href: str = Field(
        ...,
        description="Download link for document.",
        example="/api/v2/document/download_document?id=79e15217-760c-4e15-8123-414965798d60",
    )


class Meta6(BaseModel):
    content_type: Optional[str] = Field(None, alias="content-type", example="application/pdf")


class Preview(BaseModel):
    class Config:
        extra = Extra.forbid

    href: str = Field(
        ...,
        description="preview link for document.",
        example="/api/v2/document/preview_document?id=79e15217-760c-4e15-8123-414965798d60",
    )
    meta: Meta6


class Meta7(BaseModel):
    content_type: Optional[str] = Field(None, alias="content-type", example="image/jpeg")


class Thumbnail(BaseModel):
    class Config:
        extra = Extra.forbid

    href: str = Field(
        ...,
        description="thumbnail link for document.",
        example="/api/v2/document/thumbnail_document?id=79e15217-760c-4e15-8123-414965798d60",
    )
    meta: Meta7


class Links(BaseModel):
    class Config:
        extra = Extra.forbid

    download: Optional[Download] = None
    preview: Optional[Preview] = None
    thumbnail: Optional[Thumbnail] = None


class EntryType(Enum):
    document = "document"
    directory = "directory"


class Employee(BaseModel):
    name: Optional[str] = Field(None, description="Assigned employee name", example="Ina Taker")


class Role(BaseModel):
    name: Optional[str] = Field(None, description="Assigned role name", example="Document Intaker")


class Department(BaseModel):
    name: Optional[str] = Field(None, description="Assigned department name", example="Backoffice")


class Assignment(BaseModel):
    employee: Optional[Employee] = None
    role: Optional[Role] = None
    department: Optional[Department] = None


class Attributes2(BaseModel):
    class Config:
        extra = Extra.forbid

    name: str = Field(
        ...,
        description="Name of the document_entry. For type document, it is the basename(name without extension).",
        example="parkingpermit.pdf or Niew_map",
    )
    entry_type: EntryType = Field(..., description="Type of document entry", example="directory")
    description: str = Field(
        ..., description="Description about directory entry. Valid only for document."
    )
    extension: str = Field(
        ..., description="Extension of directory_entry. Valid only for document.", example="pdf"
    )
    mimetype: str = Field(
        ...,
        description="Mimetype of directory_entry. Valid only for document",
        example="application/pdf",
    )
    accepted: bool = Field(
        ..., description="Accepted status of directory_entry. Valid only for document."
    )
    document_number: Optional[int] = Field(
        None, description="Table id for document in file table. Valid only for document."
    )
    last_modified_date_time: datetime = Field(
        ..., description="Last modified date time. Valid only for document."
    )
    rejection_reason: str = Field(
        ...,
        description="Optional rejection reason for document after case assignment",
        example="Document is missing vital information.",
    )
    rejected_by_display_name: str = Field(
        ...,
        description="Optional display name of person who gave a rejection_reason",
        example="Ad Min",
    )
    assignment: Assignment


class Data7(BaseModel):
    id: Optional[UUID] = Field(None, example="b48bd549-d7c3-44cb-a02e-8e633e684360")
    type: Optional[str] = Field(None, example="directory")


class Directory1(BaseModel):
    data: Data7


class Data8(BaseModel):
    id: Optional[UUID] = Field(None, example="b48bd549-d7c3-44cb-a02e-8e633e684360")
    type: Optional[str] = Field(None, example="document")


class Document(BaseModel):
    data: Data8


class Data9(BaseModel):
    id: Optional[UUID] = Field(None, example="b48bd549-d7c3-44cb-a02e-8e633e684360")
    type: Optional[str] = Field(None, example="case")


class Meta8(BaseModel):
    display_number: Optional[float] = Field(None, example=1740)


class Case1(BaseModel):
    data: Data9
    meta: Meta8


class Data10(BaseModel):
    id: Optional[UUID] = Field(None, example="b48bd549-d7c3-44cb-a02e-8e633e684360")
    type: Optional[str] = Field(None, example="directory")


class Meta9(BaseModel):
    display_name: Optional[str] = Field(None, example="Niew map 1")


class Parent(BaseModel):
    data: Data10
    meta: Meta9


class Data11(BaseModel):
    id: Optional[UUID] = Field(None, example="b48bd549-d7c3-44cb-a02e-8e633e684360")
    type: Optional[str] = Field(None, example="subject")


class Meta10(BaseModel):
    display_name: Optional[str] = Field(None, example="Admin")


class ModifiedBy1(BaseModel):
    data: Data11
    meta: Meta10


class Relationships2(BaseModel):
    class Config:
        extra = Extra.forbid

    directory: Optional[Directory1] = Field(
        None,
        description="Reference to the directory object when directory_entry is of type directory.",
    )
    document: Optional[Document] = Field(
        None,
        description="Reference to the document object when directory_entry is of type document.",
    )
    case: Optional[Case1] = Field(None, description="Case this directory_entry is related to")
    parent: Optional[Parent] = Field(None, description="Parent directory this document_entry.")
    modified_by: Optional[ModifiedBy1] = Field(
        None, description="Subject making the last change to this document"
    )


class DirectoryEntryEntity(BaseModel):
    class Config:
        extra = Extra.forbid

    links: Links
    type: str = Field(..., example="directory_entry")
    id: UUID
    attributes: Attributes2
    relationships: Relationships2


class Attributes3(BaseModel):
    name: str


class Data12(BaseModel):
    id: Optional[UUID] = Field(None, example="b48bd549-d7c3-44cb-a02e-8e633e684360")
    type: Optional[str] = Field(None, example="directory")


class Parent1(BaseModel):
    data: Optional[Data12] = None


class Relationships3(BaseModel):
    class Config:
        extra = Extra.forbid

    parent: Optional[Parent1] = Field(None, description="Parent directory.")


class DirectoryEntity(BaseModel):
    class Config:
        extra = Extra.forbid

    type: str = Field(..., example="directory")
    id: UUID
    attributes: Attributes3
    relationships: Relationships3


class Attributes4(BaseModel):
    name: str


class DocumentLabelEntity(BaseModel):
    class Config:
        extra = Extra.forbid

    type: str = Field(..., example="document_label")
    id: UUID
    attributes: Attributes4


class DocumentCategory(Enum):
    Aangifte = "Aangifte"
    Aanmaning = "Aanmaning"
    Aanmelding = "Aanmelding"
    Aanvraag = "Aanvraag"
    Advies = "Advies"
    Afbeelding = "Afbeelding"
    Afmelding = "Afmelding"
    Afspraak = "Afspraak"
    Agenda = "Agenda"
    Akte = "Akte"
    Bankgarantie = "Bankgarantie"
    Begroting = "Begroting"
    Bekendmaking = "Bekendmaking"
    Beleidsdocument = "Beleidsdocument"
    Benoeming = "Benoeming"
    Berekening = "Berekening"
    Beroepschrift = "Beroepschrift"
    Beschikking = "Beschikking"
    Besluit = "Besluit"
    Besluitenlijst = "Besluitenlijst"
    Bestek = "Bestek"
    Bestemmingsplan = "Bestemmingsplan"
    Betaalafspraak = "Betaalafspraak"
    Betalingsherinnering = "Betalingsherinnering"
    Bevestiging = "Bevestiging"
    Bezwaarschrift = "Bezwaarschrift"
    Brochure = "Brochure"
    Catalogus = "Catalogus"
    Checklist = "Checklist"
    Circulaire = "Circulaire"
    Declaratie = "Declaratie"
    Dwangbevel = "Dwangbevel"
    Factuur = "Factuur"
    Film = "Film"
    Foto = "Foto"
    Garantiebewijs = "Garantiebewijs"
    Geluidsfragment = "Geluidsfragment"
    Gespreksverslag = "Gespreksverslag"
    Gids = "Gids"
    Grafiek = "Grafiek"
    Herinnering = "Herinnering"
    Identificatiebewijs = "Identificatiebewijs"
    Kaart = "Kaart"
    Kennisgeving = "Kennisgeving"
    Klacht = "Klacht"
    Lastgeving = "Lastgeving"
    Mededeling = "Mededeling"
    Melding = "Melding"
    Norm = "Norm"
    Nota = "Nota"
    Notitie = "Notitie"
    Offerte = "Offerte"
    Ontvangstbevestiging = "Ontvangstbevestiging"
    Ontwerp = "Ontwerp"
    Opdracht = "Opdracht"
    Overeenkomst = "Overeenkomst"
    Pakket_Van_Eisen = "Pakket Van Eisen"
    Persbericht = "Persbericht"
    Plan = "Plan"
    Plan_Van_Aanpak = "Plan Van Aanpak"
    Polis = "Polis"
    Procesbeschrijving = "Procesbeschrijving"
    Proces_verbaal = "Proces-verbaal"
    Rapport = "Rapport"
    Regeling = "Regeling"
    Register = "Register"
    Rooster = "Rooster"
    Ruimtelijk_plan = "Ruimtelijk plan"
    Sollicitatiebrief = "Sollicitatiebrief"
    Statistische_opgave = "Statistische opgave"
    Taxatierapport = "Taxatierapport"
    Technische_tekening = "Technische tekening"
    Tekening = "Tekening"
    Uitnodiging = "Uitnodiging"
    Uitspraak = "Uitspraak"
    Uittreksel = "Uittreksel"
    Vergaderverslag = "Vergaderverslag"
    Vergunning = "Vergunning"
    Verklaring = "Verklaring"
    Verordening = "Verordening"
    Verslag = "Verslag"
    Verslag_van_bevindingen = "Verslag van bevindingen"
    Verspreidingslijst = "Verspreidingslijst"
    Verweerschrift = "Verweerschrift"
    Verzoek = "Verzoek"
    Verzoekschrift = "Verzoekschrift"
    Voordracht = "Voordracht"
    Voorschrift = "Voorschrift"
    Voorstel = "Voorstel"
    Wet = "Wet"
    Zienswijze = "Zienswijze"


class DocumentConfidentiality(Enum):
    Openbaar = "Openbaar"
    Beperkt_openbaar = "Beperkt openbaar"
    Intern = "Intern"
    Zaakvertrouwelijk = "Zaakvertrouwelijk"
    Vertrouwelijk = "Vertrouwelijk"
    Confidentieel = "Confidentieel"
    Geheim = "Geheim"
    Zeer_geheim = "Zeer geheim"


class Type3(Enum):
    file = "file"


class Data13(BaseModel):
    type: Optional[Type3] = None
    id: Optional[UUID] = None


class FileSuccess(BaseModel):
    data: Optional[Data13] = None


class Data14(BaseModel):
    directory_uuid: Optional[str] = None


class DirectorySuccess(BaseModel):
    data: Optional[Data14] = None


class Meta11(BaseModel):
    api_version: Optional[int] = Field(None, example=2)


class DefaultSuccess(BaseModel):
    meta: Optional[Meta11] = None


class Links1(BaseModel):
    self: Optional[str] = Field(None, example="http://example.zs.nl/?page=2")
    prev: Optional[str] = Field(None, example="http://example.zs.nl/?page=1")
    next: Optional[str] = Field(None, example="http://example.zs.nl/?page=3")


class DefaultSuccessMultiple(DefaultSuccess):
    links: Optional[Links1] = None


class Data15(BaseModel):
    success: Optional[bool] = None


class Success(BaseModel):
    data: Optional[Data15] = None


class Links2(BaseModel):
    self: Optional[str] = Field(
        None, example="http://example.zs.nl/?uuid=39da57ba-7c8e-4638-be09-be66cdd32149"
    )


class Data16(BaseModel):
    type: Optional[str] = None
    id: Optional[UUID] = None
    links: Optional[Links2] = None


class JSONAPICommandSuccess(BaseModel):
    data: Optional[Data16] = None


class Error(BaseModel):
    error: str


class DirectoryEntryEntityMultiple(DefaultSuccessMultiple):
    data: Optional[List[DirectoryEntryEntity]] = None
    included: Optional[List[DirectoryEntity]] = None


class DocumentLabelEntityMultiple(DefaultSuccessMultiple):
    data: Optional[List[DocumentLabelEntity]] = None


class Error1(BaseModel):
    title: Optional[str] = None


class ResponseError(BaseModel):
    errors: List[Error1]


class Data17(BaseModel):
    fav_icon_url: Optional[str] = Field(None, description="fav_icon_url of the file")
    action_url: Optional[str] = Field(None, description="WOPI Action url of the file")
    access_token: Optional[str] = Field(
        None,
        description="An access token that the WOPI host will use to determine whether the request is authorized.",
    )
    access_token_ttl: Optional[str] = Field(
        None, description="Number of milliseconds the access token will be valid"
    )


class WopiJSON(BaseModel):
    data: Optional[Data17] = None


class Metadata(BaseModel):
    status: Optional[str] = Field(None, example="original")
    origin: Optional[Origin] = None
    origin_date: Optional[date] = None
    appearance: Optional[str] = None
    confidentiality: Optional[DocumentConfidentiality] = None
    structure: Optional[str] = None
    document_category: Optional[DocumentCategory] = None
    pronom_format: Optional[str] = None
    description: Optional[str] = None


class Attributes(BaseModel):
    class Config:
        extra = Extra.forbid

    basename: Optional[str] = Field(
        None, description="Basename of the file.", example="parkingpermit"
    )
    extension: Optional[str] = Field(None, description="Extension of the file.", example=".pdf")
    name: str = Field(
        ..., description="Fullname of the file with extension", example="parkingpermit.pdf"
    )
    mimetype: str = Field(..., description="Mime type of the file", example="application/pdf")
    filesize: int = Field(..., description="Size of the file", example=1234)
    md5: str = Field(..., description="md5 of the file", example="4a1f7892d2bde95g6y1ea428b99f955")
    archive: Archive = Field(..., description="contains the archive properties of the file.")
    security: Security = Field(..., description="contains the security properties of the file.")
    accepted: bool = Field(..., description="Accepted status of the document")
    current_version: Optional[int] = Field(
        None, description="Version number, an increasing value of 1-9"
    )
    status: Optional[Status] = Field(None, description="Status of the document")
    lock: Optional[Lock] = None
    metadata: Optional[Metadata] = None
    publish: Optional[Publish] = None
    tags: Optional[List[str]] = Field(
        None, description="List of tags, in case of zaaksysteem: magic strings"
    )
    integrity_check_successful: Optional[bool] = Field(
        None,
        description="true if the integrity of file is verified, else false. Shown in response only if query_parameter 'integrity' is set.",
    )


class DocumentEntity(BaseModel):
    class Config:
        extra = Extra.forbid

    type: str = Field(..., example="document")
    id: UUID
    meta: Meta
    relationships: Relationships
    attributes: Attributes


class DocumentEntityMultiple(DefaultSuccessMultiple):
    data: List[DocumentEntity]


class DocumentEntity1(DefaultSuccess):
    data: Optional[DocumentEntity] = None
